program random

   implicit none
   integer :: idim, Ndata, i, dist_type
   integer, allocatable :: arr(:)
   double precision :: ran, ran1, ran2, yy1, yy2, nran, pi = acos( -1.d0 )
   character (len=80) :: ninp

   ! Parametri di input

   print *,'Numero di valori casuali da generare:'
   read *,Ndata
   print *,'Tipo di distribuzione:'
   print *,'1) uniforme;'
   print *,'2) esponenziale;'
   print *,'3) Gaussiana.'
   read *,dist_type
   print *,'Nome del file di uscita:'
   read *,ninp

   ! Inizializzazione del generatore

   call random_seed(size=idim)
   allocate(arr(idim))
   do i=1,idim
      arr(i)=2*i+1
   enddo
   call random_seed(put=arr)

   ! Generazione dei numeri secondo la distribuzione scelta

   open (file=ninp,unit=16,status='UNKNOWN')
   do i=1,Ndata
      select case ( dist_type )
      case ( 1 )   ! Distribuzione uniforme
         call random_number( ran )
         nran = ran
      case ( 2 )   ! Distribuzione esponenziale
         call random_number( ran )
         nran = - log( ran )
      case ( 3 )
         call random_number( ran1 )
         call random_number( ran2 )
         if ( mod( i, 2 ) == 1 ) then
            yy1 = sqrt( -2.d0 * log( ran1 ) ) * cos( 2.d0 * pi * ran2 )
            nran = yy1
         else
            yy2 = sqrt( -2.d0 * log( ran1 ) ) * sin( 2.d0 * pi * ran2 )
            nran = yy2
         endif
      case default   ! come distribuzione uniforme
         call random_number( ran1 )
         nran = ran1
      end select
      write(16,*) nran
   enddo
   close(unit=16)

end program random
