module stat

contains

   double precision function media(n,x)
      implicit none
      integer :: n
      double precision :: x(n)
      double precision :: somma=0.0
      integer :: i

      do i=1,n
         somma=somma+x(i)
      enddo
      media=somma/n
   end function media

   function stdev(n,x,xm)
     implicit none
     double precision :: stdev
     integer :: n, i
     double precision :: x(n), xm, somma=0.0

     do i=1,n     
        somma=somma+(x(i)-xm)*(x(i)-xm)
     enddo
     stdev=sqrt(somma/n)
   end function stdev

   subroutine istogramma(n,x,nb,xb,yb)
      implicit none
      integer :: n, nb
      double precision :: x(n), xb(nb), yb(nb)
      double precision :: xmin, xmax, delta
      integer :: i, yc(nb), ni

      xmin=x(1)
      do i=2,n
         if (x(i) < xmin) xmin=x(i)
      enddo

      xmax=x(1)
      do i=2,n
         if (x(i) > xmax) xmax=x(i)
      enddo

      delta=(xmax-xmin)/nb
      yc=0.0
      do i=1,n
         ni=int((x(i)-xmin)/delta)+1
         if (ni==nb+1) ni=nb
         yc(ni)=yc(ni)+1
      enddo

      do i=1,nb
         xb(i)=xmin+(i-0.5)*delta
         yb(i)=dfloat(yc(i))/(n*delta)
      enddo
   end subroutine istogramma

end module stat
