program statistica

   use stat
   implicit none
   integer :: N, Nbins
   double precision, allocatable :: x(:), bin(:), cont(:)
   character(len=20) :: inpfile, outfile
   double precision :: ave, sigma

   print *,'Numero N di valori da leggere:'
   read *,N
   print *,'Nome del file di input:'
   read *,inpfile
   print *,"Numero di canali nell'istogramma:"
   read *,Nbins
   print *,'Nome del file di output:'
   read *,outfile

   allocate(x(N),bin(Nbins),cont(Nbins))
   call Leggi_dati(inpfile, N, x)

   ave=media(N,x) 
   sigma=stdev(N,x,ave)

   print *,'Media = ',ave
   print *,'Deviazione standard = ',sigma

   call istogramma(N,x,Nbins,bin,cont)
   call Scrivi_dati(outfile,Nbins,bin,cont)
   deallocate(x,bin,cont)

contains

   subroutine Leggi_dati(nfile,n,x)
      character(len=20) :: nfile
      integer :: n,i
      double precision, dimension(n) :: x

      open(file=nfile,unit=15,status='unknown')
      do i=1,n
         read(15,*) x(i)
      enddo
      close(unit=15)
   end subroutine Leggi_dati

   subroutine Scrivi_dati(nfile,n,x,y)
      character(len=20) :: nfile
      integer :: n,i
      double precision :: x(n),y(n)

      open(file=nfile,unit=16,status='unknown')
      do i=1,n
         write(16,*) x(i),y(i)
      enddo
      close(unit=16)
   end subroutine Scrivi_dati

end program statistica
